﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Styx;
using Styx.Common;
using Styx.CommonBot;
using Styx.CommonBot.Routines;
using Styx.Helpers;
using Styx.TreeSharp;
using Styx.WoWInternals;
using Styx.WoWInternals.WoWObjects;
using Action = Styx.TreeSharp.Action;
using CommonBehaviors.Actions;
using System.Runtime.InteropServices;
using System.Windows.Forms;
namespace Warena
{
    public partial class Routine
    {
        //public static string ShoutType

        //#region EnemySpec

        //public static ClassType EnemySpec(WoWUnit target)
        //{
        //    if (target == null)
        //    {
        //        return ClassType.Empty;
        //    }

        //    switch (target.Class)
        //    {
        //        case WoWClass.Monk: //TODO: check for monk
        //            return ClassType.Healer;
        //        case WoWClass.DeathKnight:
        //            return ClassType.Melee;
        //        case WoWClass.Hunter:
        //            return ClassType.PRanged;
        //        case WoWClass.Mage:
        //            return ClassType.MRanged;
        //        case WoWClass.Paladin:
        //            return target.MaxMana >= 80000 ? ClassType.Healer : ClassType.Melee;
        //        case WoWClass.Priest:
        //            return target.Shapeshift == ShapeshiftForm.Shadow ? ClassType.MRanged : ClassType.Healer;
        //        case WoWClass.Rogue:
        //            return ClassType.Melee;
        //        case WoWClass.Warlock:
        //            return ClassType.MRanged;
        //        case WoWClass.Warrior:
        //            return ClassType.Melee;
        //        case WoWClass.Shaman:
        //            if (target.MaxMana < 40000)
        //                return ClassType.Melee;
        //            if (target.Buffs.ContainsKey("Elemental Oath") && target.Buffs["Elemental Oath"].CreatorGuid == target.Guid)
        //                return ClassType.MRanged;
        //            return ClassType.Healer;
        //        case WoWClass.Druid:
        //            if (target.Shapeshift == ShapeshiftForm.Moonkin)
        //                return ClassType.MRanged;
        //            if ((target.Buffs.ContainsKey("Leader of the Pack") &&
        //                 target.Buffs["Leader of the Pack"].CreatorGuid == target.Guid) || target.MaxMana < 40000)
        //                return ClassType.Melee;
        //            return ClassType.Healer;
        //    }
        //    return ClassType.Empty;
        //}

        //#endregion

        public static byte TalentSort(WoWUnit target)
        {
            if (target == null)
            {
                return 0;
            }

            if (target.Class == WoWClass.DeathKnight)
            {
                return 1;
            }

            if (target.Class == WoWClass.Druid)
            {
                if (target.Shapeshift == ShapeshiftForm.Moonkin)
                    return 3;
                if ((target.Buffs.ContainsKey("Leader of the Pack") &&
                     target.Buffs["Leader of the Pack"].CreatorGuid == target.Guid) || target.MaxMana < 40000)
                    return 1;
                return 4;
            }

            if (target.Class == WoWClass.Hunter)
            {
                return 2;
            }

            if (target.Class == WoWClass.Mage)
            {
                return 3;
            }

            if (target.Class == WoWClass.Paladin)
            {
                if (target.MaxMana >= 80000)
                    return 4;
                return 1;
            }

            if (target.Class == WoWClass.Priest)
            {
                if (target.Shapeshift == ShapeshiftForm.Shadow)
                    return 3;
                return 4;
            }

            if (target.Class == WoWClass.Rogue)
            {
                return 1;
            }

            if (target.Class == WoWClass.Shaman)
            {
                if (target.MaxMana < 40000)
                    return 1;
                if (target.Buffs.ContainsKey("Elemental Oath") && target.Buffs["Elemental Oath"].CreatorGuid == target.Guid)
                    return 3;
                return 4;
            }

            if (target.Class == WoWClass.Warlock)
            {
                return 3;
            }

            if (target.Class == WoWClass.Warrior)
            {
                return 1;
            }

            return 0;
        }
        public byte TalentSortSimple(WoWUnit target)
        {
            byte sortSimple = TalentSort(target);

            if (sortSimple == 4)
            {
                return 4; // Healer
            }

            if (sortSimple < 4 && sortSimple > 0)
            {
                return 1; // Dps
            }

            return 0;
        }
    }
}
